{
  description = "NixOS system flake.";

  inputs = {
    nixpkgs.url = "github:nixos/nixpkgs/nixos-25.05";
    nixpkgs-unstable.url = "github:nixos/nixpkgs/nixos-unstable";
    home-manager = {
        url = "github:nix-community/home-manager/release-25.05";
        inputs.nixpkgs.follows = "nixpkgs";
    };
    # bonus inputs
    catppuccin.url = "github:catppuccin/nix";
    nur.url = "github:nix-community/NUR";
    auto-cpufreq = {
      url = "github:AdnanHodzic/auto-cpufreq";
      inputs.nixpkgs.follows = "nixpkgs";
    };
  };

  outputs = { self, nixpkgs, nixpkgs-unstable, catppuccin, nur, home-manager, auto-cpufreq, ... } @ inputs:
  let
    inherit (self) outputs;
    system = "x86_64-linux";
    timeZone = "America/Denver";
    pkgs = nixpkgs.legacyPackages.${system};
    unstablePkgs = import nixpkgs-unstable { system = system; config = { allowUnfree = true; }; };
    
    # pkgs23 = import nixpkgs-23 { system = system; config = { allowUnfree = true; }; }; 
  in
  {
    nixosConfigurations = {
      luci = nixpkgs.lib.nixosSystem {
        specialArgs = {
            inherit inputs outputs timeZone system;
        };
        modules = [
          inputs.home-manager.nixosModules.home-manager {
              home-manager.useGlobalPkgs = true;
              home-manager.useUserPackages = true;
              home-manager.users.luci = import ./luci/modules/home-manager/home.nix;
              home-manager.extraSpecialArgs = {
                  inherit inputs outputs;
              };
          }
          ./luci/default.nix
        ];
      };
      nate = nixpkgs.lib.nixosSystem {
        # Pass args to desktop configuration
        specialArgs = {
            inherit inputs outputs timeZone system;
        };
        modules = [
            catppuccin.nixosModules.catppuccin
            # Setup home manager
            inputs.home-manager.nixosModules.home-manager {
                home-manager.useGlobalPkgs = true;
                home-manager.useUserPackages = true;
                home-manager.users.nate = import ./nate/modules/home-manager/home.nix;
                home-manager.extraSpecialArgs = {
                    inherit inputs outputs unstablePkgs;
                };
            }
            ./nate/default.nix
        ];
      };
      nate-work = nixpkgs.lib.nixosSystem {
        # Pass args to desktop configuration
        specialArgs = {
            inherit inputs outputs timeZone system;
        };
        modules = [
            catppuccin.nixosModules.catppuccin
            auto-cpufreq.nixosModules.default
            # Setup home manager
            inputs.home-manager.nixosModules.home-manager {
                home-manager.useGlobalPkgs = true;
                home-manager.useUserPackages = true;
                home-manager.users.nate = {
                    imports = [
                        ./nate-work/modules/home-manager/home.nix
                        catppuccin.homeModules.catppuccin
                    ];
                };
                home-manager.extraSpecialArgs = {
                    inherit inputs outputs unstablePkgs;
                };
            }
            ./nate-work/default.nix
        ];
      };
      jaci = nixpkgs.lib.nixosSystem {
        # Pass args to desktop configuration
        specialArgs = {
            inherit inputs outputs timeZone system;
        };
        modules = [
            # Setup home manager
            inputs.home-manager.nixosModules.home-manager {
                home-manager.useGlobalPkgs = true;
                home-manager.useUserPackages = true;
                home-manager.users.jaci = import ./jaci/modules/home-manager/home.nix;
                home-manager.extraSpecialArgs = {
                    inherit inputs outputs;
                };
            }
            ./jaci/default.nix
        ];
      };
      scrappy = nixpkgs.lib.nixosSystem {
        # Pass args to desktop configuration
        specialArgs = {
            inherit inputs outputs timeZone system;
        };
        modules = [
            # Setup home manager
            inputs.home-manager.nixosModules.home-manager {
                home-manager.useGlobalPkgs = true;
                home-manager.useUserPackages = true;
                home-manager.users.scrappy = import ./scrappy/modules/home-manager/home.nix;
                home-manager.extraSpecialArgs = {
                    inherit inputs outputs unstablePkgs;
                };
            }
            ./scrappy/default.nix
        ];
      };
      frame12 = nixpkgs.lib.nixosSystem {
        # Pass args to desktop configuration
        specialArgs = {
            inherit inputs outputs timeZone system;
        };
        modules = [
            catppuccin.nixosModules.catppuccin
            # Setup home manager
            inputs.home-manager.nixosModules.home-manager {
                home-manager.useGlobalPkgs = true;
                home-manager.useUserPackages = true;
                home-manager.users.nate = {
                    imports = [
                        ./frame12/modules/home-manager/home.nix
                        catppuccin.homeModules.catppuccin
                    ];
                };
                home-manager.extraSpecialArgs = {
                    inherit inputs outputs unstablePkgs;
                };
            }
            ./frame12/default.nix
        ];
      };
    };
  };
}
